## isochron 0.9

=== Makefile ===
VERSION := $(shell ./setlocalversion)
MY_CPPFLAGS := -DVERSION=\"${VERSION}\" $(CPPFLAGS)
MY_CPPFLAGS += $(shell ./toolchain_deps.sh "$(CC)" "$(MY_CPPFLAGS)")
MY_CFLAGS := -Wall -Wextra -Werror -Wno-error=sign-compare \
	     -Wno-error=missing-field-initializers \
	     -Wno-unused-parameter $(CFLAGS)
MY_LDFLAGS := $(LDFLAGS)
CHECK := sparse
CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
	      -Wbitwise -Wno-return-void -Wno-unknown-attribute $(CF)

ifeq ($(C),1)
REAL_CC := $(CC)
CC := cgcc
export REAL_CC
endif

prefix ?= /usr/local
exec_prefix ?= ${prefix}
bindir ?= ${exec_prefix}/bin
datarootdir ?= ${prefix}/share
mandir ?= ${datarootdir}/man
PKG_CONFIG ?= pkg-config
INSTALL ?= install

src := \
	argparser.o \
	common.o \
	daemon.o \
	isochron.o \
	log.o \
	management.o \
	orchestrate.o \
	ptpmon.o \
	rcv.o \
	report.o \
	rtnl.o \
	send.o \
	sk.o \
	syncmon.o \
	sysmon.o

symlinks := \
	isochron-daemon \
	isochron-orchestrate \
	isochron-send \
	isochron-rcv \
	isochron-report

objs := $(addprefix src/, $(src))
deps := $(patsubst %.o, %.d, $(objs))

md_docs  := $(wildcard docs/*.md)
manpages := $(patsubst docs/%.md, docs/man/%, $(md_docs))

# Input: path to manpage file from sources
# Output: DESTDIR-prefixed install location
get_man_section = $(lastword $(subst ., ,$1))
get_manpage_destination = $(join $(DESTDIR)${mandir}/man, \
                          $(join $(call get_man_section,$1)/, \
                          $(subst docs/man/,,$1)))

ifeq (, $(shell which $(PKG_CONFIG)))
$(error No pkg-config binary in $(PATH))
endif

LIBMNL_CFLAGS  := $(shell ${PKG_CONFIG} --cflags libmnl)
LIBMNL_LDFLAGS := $(shell ${PKG_CONFIG} --libs libmnl)

ifeq (, $(LIBMNL_CFLAGS)$(LIBMNL_LDFLAGS))
$(error pkg-config could not find libmnl)
endif

MY_CFLAGS += $(LIBMNL_CFLAGS)
MY_LDFLAGS += $(LIBMNL_LDFLAGS)

TARGET := isochron

all: $(TARGET) man

man: $(manpages)

docs/man/%: docs/%.md
	@mkdir -p $(@D)
	pandoc --standalone --to man $^ -o $@

# include all .d files
-include $(deps)

$(TARGET): $(objs)
	$(CC) $^ -o $@ $(MY_LDFLAGS) -lm -pthread

%.o: %.c
	$(CC) $(MY_CPPFLAGS) $(MY_CFLAGS) -MMD -c $< -o $@
ifeq ($(C),1)
	$(CHECK) $(CHECKFLAGS) $(MY_CPPFLAGS) $(MY_CFLAGS) $<
endif

clean:
	rm -f $(objs) $(deps) $(TARGET)
	rm -f docs/man/*

install-manpages: $(manpages)
	$(foreach manpage, $^, $(INSTALL) -m 0644 -D $(manpage) \
		$(call get_manpage_destination,$(manpage));)

install-binaries: $(TARGET)
	$(INSTALL) -m 0755 -D $(TARGET) $(DESTDIR)${bindir}/isochron
	$(foreach symlink, $(symlinks), \
		ln -sf $(TARGET) $(DESTDIR)${bindir}/$(symlink);)

install-completion: bash-completion/isochron
	$(INSTALL) -m 0644 -D $< $(DESTDIR)${datarootdir}/bash-completion/completions/isochron
	$(foreach symlink, $(symlinks), \
		ln -sf $(TARGET) $(DESTDIR)${datarootdir}/bash-completion/completions/$(symlink);)

install: install-binaries install-manpages install-completion

## isochron 0.9~rc4

=== debian/changelog ===
isochron (0.9~rc4-1) unstable; urgency=medium

  * Initial release (Closes: #1010396)

 -- Vladimir Oltean <olteanv@gmail.com>  Thu, 19 May 2022 22:18:43 +0300

=== debian/control ===
Source: isochron
Section: utils
Priority: optional
Maintainer: Vladimir Oltean <olteanv@gmail.com>
Build-Depends: debhelper-compat (= 12), pkg-config, libmnl-dev, pandoc
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://github.com/vladimiroltean/isochron

Package: isochron
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tool for Time Sensitive Networking testing
 The isochron program is a real-time application for testing Time Sensitive
 Networking equipment. It works by monitoring the network synchronization
 status and sending time-triggered Ethernet packets. It has a server-client
 architecture and it measures network latency by taking multiple timestamps
 (some hardware, some software) along the path of the packets.

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/isochron-$1\.tar\.gz/, uversionmangle=s/-rc/~rc/" \
  https://github.com/vladimiroltean/isochron/tags .*/v?(\d\S+)\.tar\.gz

## isochron 0.9

=== debian/changelog ===
isochron (0.9-0.2) unstable; urgency=medium

  * Non-maintainer upload
  * Fix build with mips64 and ppc64
  * Fix build with glibc 2.41 (Closes: #1099237)

 -- Bastian Germann <bage@debian.org>  Mon, 03 Mar 2025 08:49:04 +0100

isochron (0.9-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version
  * Fix 64 bit time_t format on 32 bit (Closes: #1069513)
  * Scan forwarded URL

 -- Bastian Germann <bage@debian.org>  Tue, 18 Feb 2025 20:31:37 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: utils
 Priority: optional
 Maintainer: Vladimir Oltean <olteanv@gmail.com>
-Build-Depends: debhelper-compat (= 12), pkg-config, libmnl-dev, pandoc
+Build-Depends: debhelper-compat (= 12), pkgconf, libmnl-dev, pandoc
 Standards-Version: 4.6.0.1
 Rules-Requires-Root: no
-Homepage: https://github.com/vladimiroltean/isochron
+Homepage: https://github.com/NXP/isochron
 
 Package: isochron
 Architecture: linux-any

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk
export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/isochron-$1\.tar\.gz/, uversionmangle=s/-rc/~rc/" \
  https://github.com/NXP/isochron/tags .*/v?(\d\S+)\.tar\.gz
